--- //depot/vendor/freebsd/src/sys/netinet/tcp_syncache.c	2005/04/21 20:30:38
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_syncache.c	2005/06/01 10:10:04
@@ -556,6 +556,9 @@
 		goto abort2;
 	}
 #ifdef MAC
+	/*
+	 * XXXRW: Would prefer inpcb.
+	 */
 	SOCK_LOCK(so);
 	mac_set_socket_peer_from_mbuf(m, so);
 	SOCK_UNLOCK(so);
@@ -719,6 +722,14 @@
 abort:
 	INP_UNLOCK(inp);
 abort2:
+	/*
+	 * XXXRW: Technically speaking, this soabort() likely doesn't
+	 * do anything, since we insert sockets into the accept queues
+	 * in an already completed state, and soabort() leaves it to
+	 * the close() on the listen socket to remove completed
+	 * connections.  However, this means a TCP socket without
+	 * full TCP state could slip through...?
+	 */
 	if (so != NULL)
 		(void) soabort(so);
 	return (NULL);
--- //depot/vendor/freebsd/src/sys/netinet/tcp_timer.c	2005/05/21 00:40:18
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_timer.c	2005/06/01 10:10:04
@@ -263,6 +263,9 @@
 		LIST_REMOVE(tw, tw_2msl);
 	tw->tw_time = timeo + ticks;
 	i = timeo > tcp_msl ? 1 : 0;
+	/*
+	 * XXXRW: Locking?
+	 */
 	tw_tail = &twl_2msl[i].tw_tail;
 	LIST_INSERT_BEFORE(tw_tail, tw, tw_2msl);
 }
@@ -272,6 +275,7 @@
 {
 
 	INP_INFO_WLOCK_ASSERT(&tcbinfo);
+	/* XXXRW: Assert tw lock? */
 	if (tw->tw_time != 0)
 		LIST_REMOVE(tw, tw_2msl);
 }
--- //depot/vendor/freebsd/src/sys/netinet/tcp_usrreq.c	2005/06/01 12:15:19
+++ //depot/user/rwatson/netperf/sys/netinet/tcp_usrreq.c	2005/07/05 14:55:33
@@ -146,6 +146,50 @@
 }
 
 /*
+ * Common code to setup and teardown locking.  Most
+ * code begins with a COMMON_START macro and finishes
+ * with COMMON_END.  You indicate whether the inpcb
+ * and enclosing head are to be locked read or write.
+ */
+#define INI_NOLOCK	0		/* no head lock */
+#define INI_READ	1		/* read head lock */
+#define INI_WRITE	2		/* write head lock */
+
+#define	COMMON_START0(_headrw) do {				\
+	if (_headrw == INI_READ)				\
+		INP_INFO_RLOCK(&tcbinfo);			\
+	else if (_headrw == INI_WRITE)				\
+		INP_INFO_WLOCK(&tcbinfo);			\
+	inp = sotoinpcb(so);					\
+	if (inp == 0) {						\
+		if (_headrw == INI_READ)			\
+			INP_INFO_RUNLOCK(&tcbinfo);		\
+		else if (_headrw == INI_WRITE)			\
+			INP_INFO_WUNLOCK(&tcbinfo);		\
+		return EINVAL;					\
+	}							\
+	INP_LOCK(inp);						\
+	if (_headrw == INI_READ)				\
+		INP_INFO_RUNLOCK(&tcbinfo);			\
+	tp = intotcpcb(inp);					\
+	TCPDEBUG1();						\
+} while(0)
+
+#define	COMMON_START(_headrw) do {				\
+	TCPDEBUG0;						\
+	COMMON_START0(_headrw);					\
+} while (0)
+
+#define COMMON_END(_headrw, req)				\
+	TCPDEBUG2(req);						\
+	do {							\
+		if (tp)						\
+			INP_UNLOCK(inp);			\
+		if (_headrw == INI_WRITE)			\
+			INP_INFO_WUNLOCK(&tcbinfo);		\
+	} while(0)
+
+/*
  * pru_detach() detaches the TCP protocol from the socket.
  * If the protocol state is non-embryonic, then can't
  * do this directly: have to initiate a pru_disconnect(),
@@ -158,63 +202,13 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	TCPDEBUG0;
 
-	INP_INFO_WLOCK(&tcbinfo);
-	inp = sotoinpcb(so);
-	if (inp == NULL) {
-		INP_INFO_WUNLOCK(&tcbinfo);
-		return error;
-	}
-	INP_LOCK(inp);
-	tp = intotcpcb(inp);
-	TCPDEBUG1();
+	COMMON_START(INI_WRITE);
 	tp = tcp_disconnect(tp);
-
-	TCPDEBUG2(PRU_DETACH);
-	if (tp)
-		INP_UNLOCK(inp);
-	INP_INFO_WUNLOCK(&tcbinfo);
+	COMMON_END(INI_WRITE, PRU_DETACH);
 	return error;
 }
 
-#define INI_NOLOCK	0
-#define INI_READ	1
-#define INI_WRITE	2
-
-#define	COMMON_START()						\
-	TCPDEBUG0;						\
-	do {							\
-		if (inirw == INI_READ)				\
-			INP_INFO_RLOCK(&tcbinfo);		\
-		else if (inirw == INI_WRITE)			\
-			INP_INFO_WLOCK(&tcbinfo);		\
-		inp = sotoinpcb(so);				\
-		if (inp == 0) {					\
-			if (inirw == INI_READ)			\
-				INP_INFO_RUNLOCK(&tcbinfo);	\
-			else if (inirw == INI_WRITE)		\
-				INP_INFO_WUNLOCK(&tcbinfo);	\
-			return EINVAL;				\
-		}						\
-		INP_LOCK(inp);					\
-		if (inirw == INI_READ)				\
-			INP_INFO_RUNLOCK(&tcbinfo);		\
-		tp = intotcpcb(inp);				\
-		TCPDEBUG1();					\
-} while(0)
-
-#define COMMON_END(req)						\
-out:	TCPDEBUG2(req);						\
-	do {							\
-		if (tp)						\
-			INP_UNLOCK(inp);			\
-		if (inirw == INI_WRITE)				\
-			INP_INFO_WUNLOCK(&tcbinfo);		\
-		return error;					\
-		goto out;					\
-} while(0)
-
 /*
  * Give the socket an address.
  */
@@ -225,7 +219,6 @@
 	struct inpcb *inp;
 	struct tcpcb *tp;
 	struct sockaddr_in *sinp;
-	const int inirw = INI_WRITE;
 
 	sinp = (struct sockaddr_in *)nam;
 	if (nam->sa_len != sizeof (*sinp))
@@ -238,11 +231,10 @@
 	    IN_MULTICAST(ntohl(sinp->sin_addr.s_addr)))
 		return (EAFNOSUPPORT);
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	error = in_pcbbind(inp, nam, td->td_ucred);
-	if (error)
-		goto out;
-	COMMON_END(PRU_BIND);
+	COMMON_END(INI_WRITE, PRU_BIND);
+	return error;
 }
 
 #ifdef INET6
@@ -253,7 +245,6 @@
 	struct inpcb *inp;
 	struct tcpcb *tp;
 	struct sockaddr_in6 *sin6p;
-	const int inirw = INI_WRITE;
 
 	sin6p = (struct sockaddr_in6 *)nam;
 	if (nam->sa_len != sizeof (*sin6p))
@@ -266,7 +257,7 @@
 	    IN6_IS_ADDR_MULTICAST(&sin6p->sin6_addr))
 		return (EAFNOSUPPORT);
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	inp->inp_vflag &= ~INP_IPV4;
 	inp->inp_vflag |= INP_IPV6;
 	if ((inp->inp_flags & IN6P_IPV6_V6ONLY) == 0) {
@@ -284,9 +275,9 @@
 		}
 	}
 	error = in6_pcbbind(inp, nam, td->td_ucred);
-	if (error)
-		goto out;
-	COMMON_END(PRU_BIND);
+out:
+	COMMON_END(INI_WRITE, PRU_BIND);
+	return error;
 }
 #endif /* INET6 */
 
@@ -299,9 +290,8 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_WRITE;
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	SOCK_LOCK(so);
 	error = solisten_proto_check(so);
 	if (error == 0 && inp->inp_lport == 0)
@@ -311,7 +301,8 @@
 		solisten_proto(so);
 	}
 	SOCK_UNLOCK(so);
-	COMMON_END(PRU_LISTEN);
+	COMMON_END(INI_WRITE, PRU_LISTEN);
+	return error;
 }
 
 #ifdef INET6
@@ -321,9 +312,8 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_WRITE;
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	SOCK_LOCK(so);
 	error = solisten_proto_check(so);
 	if (error == 0 && inp->inp_lport == 0) {
@@ -337,7 +327,8 @@
 		solisten_proto(so);
 	}
 	SOCK_UNLOCK(so);
-	COMMON_END(PRU_LISTEN);
+	COMMON_END(INI_WRITE, PRU_LISTEN);
+	return error;
 }
 #endif /* INET6 */
 
@@ -355,7 +346,6 @@
 	struct inpcb *inp;
 	struct tcpcb *tp;
 	struct sockaddr_in *sinp;
-	const int inirw = INI_WRITE;
 
 	sinp = (struct sockaddr_in *)nam;
 	if (nam->sa_len != sizeof (*sinp))
@@ -369,11 +359,13 @@
 	if (jailed(td->td_ucred))
 		prison_remote_ip(td->td_ucred, 0, &sinp->sin_addr.s_addr);
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	if ((error = tcp_connect(tp, nam, td)) != 0)
 		goto out;
 	error = tcp_output(tp);
-	COMMON_END(PRU_CONNECT);
+out:
+	COMMON_END(INI_WRITE, PRU_CONNECT);
+	return error;
 }
 
 #ifdef INET6
@@ -384,7 +376,6 @@
 	struct inpcb *inp;
 	struct tcpcb *tp;
 	struct sockaddr_in6 *sin6p;
-	const int inirw = INI_WRITE;
 
 	sin6p = (struct sockaddr_in6 *)nam;
 	if (nam->sa_len != sizeof (*sin6p))
@@ -396,7 +387,7 @@
 	    && IN6_IS_ADDR_MULTICAST(&sin6p->sin6_addr))
 		return (EAFNOSUPPORT);
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	if (IN6_IS_ADDR_V4MAPPED(&sin6p->sin6_addr)) {
 		struct sockaddr_in sin;
 
@@ -419,7 +410,9 @@
 	if ((error = tcp6_connect(tp, nam, td)) != 0)
 		goto out;
 	error = tcp_output(tp);
-	COMMON_END(PRU_CONNECT);
+out:
+	COMMON_END(INI_WRITE, PRU_CONNECT);
+	return error;
 }
 #endif /* INET6 */
 
@@ -440,11 +433,11 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_WRITE;
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	tp = tcp_disconnect(tp);
-	COMMON_END(PRU_DISCONNECT);
+	COMMON_END(INI_WRITE, PRU_DISCONNECT);
+	return error;
 }
 
 /*
@@ -462,33 +455,24 @@
 	in_port_t port = 0;
 	TCPDEBUG0;
 
+	/* Unlocked read. */
 	if (so->so_state & SS_ISDISCONNECTED) {
 		error = ECONNABORTED;
-		goto out;
+		goto out;	/* NB: ok 'cuz tp is NULL */
 	}
 
-	INP_INFO_RLOCK(&tcbinfo);
-	inp = sotoinpcb(so);
-	if (!inp) {
-		INP_INFO_RUNLOCK(&tcbinfo);
-		return (EINVAL);
-	}
-	INP_LOCK(inp);
-	INP_INFO_RUNLOCK(&tcbinfo);
-	tp = intotcpcb(inp);
-	TCPDEBUG1();
+	COMMON_START0(INI_READ);
 
 	/*
-	 * We inline in_setpeeraddr and COMMON_END here, so that we can
-	 * copy the data of interest and defer the malloc until after we
-	 * release the lock.
+	 * We inline in_setpeeraddr so that we can copy the
+	 * data of interest and defer the malloc until after
+	 * we release the lock.
 	 */
 	port = inp->inp_fport;
 	addr = inp->inp_faddr;
 
-out:	TCPDEBUG2(PRU_ACCEPT);
-	if (tp)
-		INP_UNLOCK(inp);
+out:
+	COMMON_END(INI_READ, PRU_ACCEPT);
 	if (error == 0)
 		*nam = in_sockaddr(port, &addr);
 	return error;
@@ -507,25 +491,17 @@
 	int v4 = 0;
 	TCPDEBUG0;
 
+	/* Unlocked read. */
 	if (so->so_state & SS_ISDISCONNECTED) {
 		error = ECONNABORTED;
-		goto out;
+		goto out;		/* NB: ok 'cuz tp is NULL */
 	}
 
-	INP_INFO_RLOCK(&tcbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_RUNLOCK(&tcbinfo);
-		return (EINVAL);
-	}
-	INP_LOCK(inp);
-	INP_INFO_RUNLOCK(&tcbinfo);
-	tp = intotcpcb(inp);
-	TCPDEBUG1();
+	COMMON_START0(INI_READ);
 	/*
-	 * We inline in6_mapped_peeraddr and COMMON_END here, so that we can
-	 * copy the data of interest and defer the malloc until after we
-	 * release the lock.
+	 * We inline in6_mapped_peeraddr so that we can
+	 * copy the data of interest and defer the malloc
+	 * until after we release the lock.
 	 */
 	if (inp->inp_vflag & INP_IPV4) {
 		v4 = 1;
@@ -536,9 +512,8 @@
 		addr6 = inp->in6p_faddr;
 	}
 
-out:	TCPDEBUG2(PRU_ACCEPT);
-	if (tp)
-		INP_UNLOCK(inp);
+out:
+	COMMON_END(INI_READ, PRU_ACCEPT);
 	if (error == 0) {
 		if (v4)
 			*nam = in6_v4mapsin6_sockaddr(port, &addr);
@@ -579,14 +554,14 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_WRITE;
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	socantsendmore(so);
 	tp = tcp_usrclosed(tp);
 	if (tp)
 		error = tcp_output(tp);
-	COMMON_END(PRU_SHUTDOWN);
+	COMMON_END(INI_WRITE, PRU_SHUTDOWN);
+	return error;
 }
 
 /*
@@ -598,11 +573,11 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_READ;
 
-	COMMON_START();
+	COMMON_START(INI_READ);
 	tcp_output(tp);
-	COMMON_END(PRU_RCVD);
+	COMMON_END(INI_READ, PRU_RCVD);
+	return error;
 }
 
 /*
@@ -741,12 +716,14 @@
 		}
 		INP_INFO_WUNLOCK(&tcbinfo);
 		unlocked = 1;
+		/* Unlocked read of sb_cc. */
 		tp->snd_up = tp->snd_una + so->so_snd.sb_cc;
 		tp->t_flags |= TF_FORCEDATA;
 		error = tcp_output(tp);
 		tp->t_flags &= ~TF_FORCEDATA;
 	}
 out:
+	COMMON_END(INI_WRITE, (flags & PRUS_OOB) ? PRU_SENDOOB :
 	TCPDEBUG2((flags & PRUS_OOB) ? PRU_SENDOOB :
 		  ((flags & PRUS_EOF) ? PRU_SEND_EOF : PRU_SEND));
 	if (tp)
@@ -754,6 +731,7 @@
 	if (!unlocked)
 		INP_INFO_WUNLOCK(&tcbinfo);
 	return (error);
+	return error;
 }
 
 /*
@@ -765,11 +743,11 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_WRITE;
 
-	COMMON_START();
+	COMMON_START(INI_WRITE);
 	tp = tcp_drop(tp, ECONNABORTED);
-	COMMON_END(PRU_ABORT);
+	COMMON_END(INI_WRITE, PRU_ABORT);
+	return error;
 }
 
 /*
@@ -781,9 +759,9 @@
 	int error = 0;
 	struct inpcb *inp;
 	struct tcpcb *tp;
-	const int inirw = INI_READ;
 
-	COMMON_START();
+	COMMON_START(INI_READ);
+	/* Unlocked read. */
 	if ((so->so_oobmark == 0 &&
 	     (so->so_rcv.sb_state & SBS_RCVATMARK) == 0) ||
 	    so->so_options & SO_OOBINLINE ||
@@ -799,7 +777,9 @@
 	*mtod(m, caddr_t) = tp->t_iobc;
 	if ((flags & MSG_PEEK) == 0)
 		tp->t_oobflags ^= (TCPOOB_HAVEDATA | TCPOOB_HADDATA);
-	COMMON_END(PRU_RCVOOB);
+out:
+	COMMON_END(INI_READ, PRU_RCVOOB);
+	return error;
 }
 
 struct pr_usrreqs tcp_usrreqs = {
@@ -1207,11 +1187,23 @@
 #endif
 	inp->inp_vflag |= INP_IPV4;
 	tp = tcp_newtcpcb(inp);
-	if (tp == 0) {
-		int nofd = so->so_state & SS_NOFDREF;	/* XXX */
+	if (tp == NULL) {
+		int nofd;
+		/*
+		 * XXXRW: This is a potentially racy scenario: we perform
+		 * a read-update-write on so_state but don't hold a lock,
+		 * not to mention calling out to external code that may
+		 * grab locks.  This section requires attention.
+		 *
+		 * XXXRW: Or not, this is in a local socket attach?
+		 */
+		SOCK_LOCK(so);
+		nofd = so->so_state & SS_NOFDREF;
+		/* don't free the socket yet */
+		if (nofd)
+			so->so_state &= ~SS_NOFDREF;
+		SOCK_UNLOCK(so);
 
-		so->so_state &= ~SS_NOFDREF;	/* don't free the socket yet */
-
 		INP_LOCK(inp);
 #ifdef INET6
 		if (isipv6)
@@ -1219,7 +1211,9 @@
 		else
 #endif
 		in_pcbdetach(inp);
+		SOCK_LOCK(so);
 		so->so_state |= nofd;
+		SOCK_UNLOCK(so);
 		return (ENOBUFS);
 	}
 	tp->t_state = TCPS_CLOSED;
--- //depot/vendor/freebsd/src/sys/netinet/udp_usrreq.c	2005/06/01 11:25:19
+++ //depot/user/rwatson/netperf/sys/netinet/udp_usrreq.c	2005/07/05 14:55:33
@@ -691,10 +691,10 @@
 	int unlock_udbinfo;
 
 	/*
-	 * udp_output() may need to temporarily bind or connect the current
-	 * inpcb.  As such, we don't know up front what inpcb locks we will
-	 * need.  Do any work to decide what is needed up front before
-	 * acquiring locks.
+	 * XXXRW: udp_output() may need to temporarily bind or connect the
+	 * current inpcb.  As such, we don't know up front what inpcb locks
+	 * we will need.  Do any work to decide what is needed up front
+	 * before acquiring locks.
 	 */
 	if (len + sizeof(struct udpiphdr) > IP_MAXPACKET) {
 		if (control)
@@ -737,6 +737,9 @@
 				src.sin_family = AF_INET;
 				src.sin_len = sizeof(src);
 				src.sin_port = inp->inp_lport;
+				/*
+				 * XXXRW: alignment?
+				 */
 				src.sin_addr = *(struct in_addr *)CMSG_DATA(cm);
 				break;
 			default:
@@ -753,6 +756,12 @@
 		return error;
 	}
 
+	/*
+	 * XXXRW: We now have all the information we need in order to
+	 * determine what locks are required.  The temporary binding behavior
+	 * here is expensive and undesirable.  The current use of a local
+	 * variable to track lock state is also unpretty.
+	 */
 	if (src.sin_addr.s_addr != INADDR_ANY ||
 	    addr != NULL) {
 		INP_INFO_WLOCK(&udbinfo);
@@ -899,18 +908,47 @@
 SYSCTL_INT(_net_inet_udp, UDPCTL_RECVSPACE, recvspace, CTLFLAG_RW,
     &udp_recvspace, 0, "Maximum space for incoming UDP datagrams");
 
+/*
+ * Common code to setup and teardown locking.  Most
+ * code begins with a COMMON_START macro and finishes
+ * with COMMON_END.  You indicate whether the inpcb
+ * and enclosing head are to be locked read or write .
+ */
+#define INI_NOLOCK	0		/* no head lock */
+#define INI_READ	1		/* read head lock */
+#define INI_WRITE	2		/* write head lock */
+
+#define	COMMON_START(_headrw) do {				\
+	if (_headrw == INI_READ)				\
+		INP_INFO_RLOCK(&udbinfo);			\
+	else if (_headrw == INI_WRITE)				\
+		INP_INFO_WLOCK(&udbinfo);			\
+	inp = sotoinpcb(so);					\
+	if (inp == 0) {						\
+		if (_headrw == INI_READ)			\
+			INP_INFO_RUNLOCK(&udbinfo);		\
+		else if (_headrw == INI_WRITE)			\
+			INP_INFO_WUNLOCK(&udbinfo);		\
+		return EINVAL;					\
+	}							\
+	INP_LOCK(inp);						\
+	if (_headrw == INI_READ)				\
+		INP_INFO_RUNLOCK(&udbinfo);			\
+} while(0)
+
+#define COMMON_END(_headrw)					\
+	do {							\
+		INP_UNLOCK(inp);				\
+		if (_headrw == INI_WRITE)			\
+			INP_INFO_WUNLOCK(&udbinfo);		\
+	} while(0)
+
 static int
 udp_abort(struct socket *so)
 {
 	struct inpcb *inp;
 
-	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;	/* ??? possible? panic instead? */
-	}
-	INP_LOCK(inp);
+	COMMON_START(INI_WRITE);
 	soisdisconnected(so);
 	in_pcbdetach(inp);
 	INP_INFO_WUNLOCK(&udbinfo);
@@ -975,17 +1013,10 @@
 	int error;
 	struct sockaddr_in *sin;
 
-	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
-	INP_LOCK(inp);
+	COMMON_START(INI_WRITE);
 	if (inp->inp_faddr.s_addr != INADDR_ANY) {
-		INP_UNLOCK(inp);
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EISCONN;
+		error = EISCONN;
+		goto out;
 	}
 	sin = (struct sockaddr_in *)nam;
 	if (jailed(td->td_ucred))
@@ -993,8 +1024,8 @@
 	error = in_pcbconnect(inp, nam, td->td_ucred);
 	if (error == 0)
 		soisconnected(so);
-	INP_UNLOCK(inp);
-	INP_INFO_WUNLOCK(&udbinfo);
+out:
+	COMMON_END(INI_WRITE);
 	return error;
 }
 
@@ -1018,19 +1049,13 @@
 static int
 udp_disconnect(struct socket *so)
 {
+	int error = 0;
 	struct inpcb *inp;
 
-	INP_INFO_WLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		return EINVAL;
-	}
-	INP_LOCK(inp);
+	COMMON_START(INI_WRITE);
 	if (inp->inp_faddr.s_addr == INADDR_ANY) {
-		INP_INFO_WUNLOCK(&udbinfo);
-		INP_UNLOCK(inp);
-		return ENOTCONN;
+		error = ENOTCONN;
+		goto out;
 	}
 
 	in_pcbdisconnect(inp);
@@ -1038,7 +1063,8 @@
 	INP_UNLOCK(inp);
 	INP_INFO_WUNLOCK(&udbinfo);
 	so->so_state &= ~SS_ISCONNECTED;		/* XXX */
-	return 0;
+out:
+	return error;
 }
 
 static int
@@ -1056,16 +1082,9 @@
 {
 	struct inpcb *inp;
 
-	INP_INFO_RLOCK(&udbinfo);
-	inp = sotoinpcb(so);
-	if (inp == 0) {
-		INP_INFO_RUNLOCK(&udbinfo);
-		return EINVAL;
-	}
-	INP_LOCK(inp);
-	INP_INFO_RUNLOCK(&udbinfo);
+	COMMON_START(INI_READ);
 	socantsendmore(so);
-	INP_UNLOCK(inp);
+	COMMON_END(INI_READ);
 	return 0;
 }
 
--- //depot/vendor/freebsd/src/sys/netinet6/in6_gif.c	2005/06/20 20:20:47
+++ //depot/user/rwatson/netperf/sys/netinet6/in6_gif.c	2005/07/05 14:55:33
@@ -82,6 +82,11 @@
   &rip6_usrreqs
 };
 
+/*
+ * XXXRW: in6_gif per-softc locking required.  Need to lock both the
+ * members, and also prevent the softc from disappearing during use
+ * including the route).
+ */
 int
 in6_gif_output(ifp, family, m)
 	struct ifnet *ifp;
@@ -394,6 +399,10 @@
 in6_gif_attach(sc)
 	struct gif_softc *sc;
 {
+
+	/*
+	 * XXXRW: Technically, encap_attach() can return NULL due to ENOMEM?
+	 */
 	sc->encap_cookie6 = encap_attach_func(AF_INET6, -1, gif_encapcheck,
 	    (struct protosw *)&in6_gif_protosw, sc);
 	if (sc->encap_cookie6 == NULL)
--- //depot/vendor/freebsd/src/sys/netinet6/in6_ifattach.c	2005/02/22 13:06:15
+++ //depot/user/rwatson/netperf/sys/netinet6/in6_ifattach.c	2005/02/27 16:23:38
@@ -226,8 +226,8 @@
 	struct sockaddr_dl *sdl;
 	u_int8_t *addr;
 	size_t addrlen;
-	static u_int8_t allzero[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
-	static u_int8_t allone[8] =
+	static const u_int8_t allzero[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
+	static const u_int8_t allone[8] =
 		{ 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
 
 	for (ifa = ifp->if_addrlist.tqh_first;
--- //depot/vendor/freebsd/src/sys/netinet6/in6_pcb.c	2005/01/07 02:32:16
+++ //depot/user/rwatson/netperf/sys/netinet6/in6_pcb.c	2005/02/27 16:23:38
@@ -414,6 +414,7 @@
 #ifdef IPSEC
 	ipsec_pcbdisconn(inp->inp_sp);
 #endif
+	/* Unlocked read. */
 	if (inp->inp_socket->so_state & SS_NOFDREF)
 		in6_pcbdetach(inp);
 }
--- //depot/vendor/freebsd/src/sys/netinet6/in6_proto.c	2005/02/22 13:06:15
+++ //depot/user/rwatson/netperf/sys/netinet6/in6_proto.c	2005/02/27 16:23:38
@@ -67,6 +67,8 @@
 #include "opt_carp.h"
 
 #include <sys/param.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/protosw.h>
--- //depot/vendor/freebsd/src/sys/netinet6/in6_rmx.c	2005/01/07 02:32:16
+++ //depot/user/rwatson/netperf/sys/netinet6/in6_rmx.c	2005/02/27 16:23:38
@@ -79,6 +79,8 @@
 #include <sys/sysctl.h>
 #include <sys/queue.h>
 #include <sys/socket.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
 #include <sys/socketvar.h>
 #include <sys/mbuf.h>
 #include <sys/syslog.h>
--- //depot/vendor/freebsd/src/sys/netinet6/ip6_forward.c	2005/01/07 02:32:16
+++ //depot/user/rwatson/netperf/sys/netinet6/ip6_forward.c	2005/02/27 16:23:38
@@ -85,6 +85,9 @@
 
 #include <netinet6/ip6protosw.h>
 
+/*
+ * XXXRW: The route cache needs synchronization, or removal as in IPv4.
+ */
 struct	route_in6 ip6_forward_rt;
 
 /*
--- //depot/vendor/freebsd/src/sys/netinet6/ip6_input.c	2005/03/16 05:15:18
+++ //depot/user/rwatson/netperf/sys/netinet6/ip6_input.c	2005/06/01 10:10:04
@@ -195,7 +195,7 @@
 
 	ip6intrq.ifq_maxlen = ip6qmaxlen;
 	mtx_init(&ip6intrq.ifq_mtx, "ip6_inq", NULL, MTX_DEF);
-	netisr_register(NETISR_IPV6, ip6_input, &ip6intrq, 0);
+	netisr_register(NETISR_IPV6, ip6_input, &ip6intrq, NETISR_MPSAFE);
 	scope6_init();
 	addrsel_policy_init();
 	nd6_init();
@@ -241,7 +241,6 @@
 	struct in6_addr odst;
 	int srcrt = 0;
 
-	GIANT_REQUIRED;			/* XXX for now */
 #ifdef IPSEC
 	/*
 	 * should the inner packet be considered authentic?
--- //depot/vendor/freebsd/src/sys/netinet6/ip6_output.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/netinet6/ip6_output.c	2005/07/05 14:55:33
@@ -2101,6 +2101,7 @@
 
 				bzero(&sro, sizeof(sro));
 
+				/* Unlocked read. */
 				if (!(so->so_state & SS_ISCONNECTED))
 					return (ENOTCONN);
 				/*
--- //depot/vendor/freebsd/src/sys/netinet6/nd6.c	2005/02/22 13:06:15
+++ //depot/user/rwatson/netperf/sys/netinet6/nd6.c	2005/02/27 16:23:38
@@ -97,6 +97,9 @@
 /* for debugging? */
 static int nd6_inuse, nd6_allocated;
 
+/*
+ * XXXRW: What follows requires locking.
+ */
 struct llinfo_nd6 llinfo_nd6 = {&llinfo_nd6, &llinfo_nd6};
 struct nd_drhead nd_defrouter;
 struct nd_prhead nd_prefix = { 0 };
@@ -1798,6 +1801,13 @@
 	    nd6_slowtimo, NULL);
 	IFNET_RLOCK();
 	for (ifp = TAILQ_FIRST(&ifnet); ifp; ifp = TAILQ_NEXT(ifp, if_list)) {
+		/*
+		 * XXXRW: Temporary work-around for the fact that the timeout
+		 * can fire during interface initialization, racing with the
+		 * code that is intended to initialize this field.
+		 */
+		if (ifp->if_afdata[AF_INET6] == NULL)
+			continue;
 		nd6if = ND_IFINFO(ifp);
 		if (nd6if->basereachable && /* already initialized */
 		    (nd6if->recalctm -= ND6_SLOWTIMER_INTERVAL) <= 0) {
--- //depot/vendor/freebsd/src/sys/netinet6/raw_ip6.c	2005/03/29 01:30:18
+++ //depot/user/rwatson/netperf/sys/netinet6/raw_ip6.c	2005/06/01 10:10:04
@@ -639,6 +639,7 @@
 {
 	struct inpcb *inp = sotoinpcb(so);
 
+	/* Unlocked read. */
 	if ((so->so_state & SS_ISCONNECTED) == 0)
 		return ENOTCONN;
 	inp->in6p_faddr = in6addr_any;
--- //depot/vendor/freebsd/src/sys/netipsec/keysock.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netipsec/keysock.c	2005/02/27 16:23:38
@@ -306,6 +306,11 @@
 		pfkeystat.in_msgtype[msg->sadb_msg_type]++;
 	}
 
+	/*
+	 * XXXRW: This will almost certainly cause lock order problems;
+	 * we may need a netisr solution similar to that used in rtsock.
+	 */
+	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list)
 	{
 		if (rp->rcb_proto.sp_family != PF_KEY)
@@ -354,18 +359,21 @@
 			continue;
 
 		if ((n = m_copy(m, 0, (int)M_COPYALL)) == NULL) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			pfkeystat.in_nomem++;
 			return ENOBUFS;
 		}
 
 		if ((error = key_sendup0(rp, n, 0)) != 0) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			return error;
 		}
 
 		n = NULL;
 	}
+	mtx_lock(&rawcb_mtx);
 
 	if (so) {
 		error = key_sendup0(sotorawcb(so), m, 0);
--- //depot/vendor/freebsd/src/sys/netipx/ipx_input.c	2005/04/10 18:05:47
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_input.c	2005/06/01 10:10:04
@@ -82,7 +82,15 @@
 					    .s_host[1] = 0xffff,
 					    .s_host[2] = 0xffff };
 
+/*
+ * XXXRW: Locking needed here.
+ */
 struct	ipxstat ipxstat;
+
+/*
+ * XXXRW: These should/could also be const, since they're set only at
+ * init time.
+ */
 struct	sockaddr_ipx ipx_netmask, ipx_hostmask;
 
 /*
@@ -117,6 +125,9 @@
 
 	IPX_LIST_LOCK_INIT();
 
+	/*
+	 * XXXRW: These should be const?
+	 */
 	ipx_netmask.sipx_len = 6;
 	ipx_netmask.sipx_addr.x_net = ipx_broadnet;
 
@@ -472,6 +483,14 @@
 	}
 }
 
+/*
+ * XXXRW: Herein lies the largest locking problem in netipx: ipx_outputfl()
+ * loops back into ipx_watch_output() to re-inject packets back into an
+ * ipxpcb if raw sockets are listening for all packets.  Since ipx_outputfl()
+ * is called from the outbound path with potentially list and ipxpcb locks
+ * held, things get sticky.  We may want to insert a netisr deferal of the
+ * loop back into the raw socket layer.
+ */
 void
 ipx_watch_output(m, ifp)
 struct mbuf *m;
--- //depot/vendor/freebsd/src/sys/netipx/ipx_outputfl.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_outputfl.c	2005/02/27 16:23:38
@@ -1,4 +1,5 @@
 /*-
+ * Copyright (c) 2005 Robert N. M. Watson
  * Copyright (c) 1995, Mike Mitchell
  * Copyright (c) 1984, 1985, 1986, 1987, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -129,6 +130,10 @@
 	if (htons(ipx->ipx_len) <= ifp->if_mtu) {
 		ipxstat.ipxs_localout++;
 		if (ipx_copy_output) {
+			/*
+			 * XXXRW: We don't know if the caller holds the list
+			 * lock or not.
+			 */
 			ipx_watch_output(m0, ifp);
 		}
 		error = (*ifp->if_output)(ifp, m0,
@@ -140,6 +145,10 @@
 	}
 bad:
 	if (ipx_copy_output) {
+		/*
+		 * XXXRW: We don't know if the caller holds the list lock or
+		 * not.
+		 */
 		ipx_watch_output(m0, ifp);
 	}
 	m_freem(m0);
--- //depot/vendor/freebsd/src/sys/netipx/ipx_pcb.c	2005/01/09 05:10:49
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_pcb.c	2005/02/27 16:23:38
@@ -115,6 +115,9 @@
 	}
 	ipxp->ipxp_laddr = sipx->sipx_addr;
 noname:
+	/*
+	 * XXXRW: I wonder what guarantees this loop will terminate...
+	 */
 	if (lport == 0)
 		do {
 			ipxpcb_lport_cache++;
--- //depot/vendor/freebsd/src/sys/netipx/ipx_usrreq.c	2005/01/09 05:20:42
+++ //depot/user/rwatson/netperf/sys/netipx/ipx_usrreq.c	2005/02/27 16:23:38
@@ -134,11 +134,10 @@
 	 * Construct sockaddr format source address.
 	 * Stuff source address and datagram in user buffer.
 	 */
+	bzero(&ipx_ipx, sizeof(ipx_ipx));
 	ipx_ipx.sipx_len = sizeof(ipx_ipx);
 	ipx_ipx.sipx_family = AF_IPX;
 	ipx_ipx.sipx_addr = ipx->ipx_sna;
-	ipx_ipx.sipx_zero[0] = '\0';
-	ipx_ipx.sipx_zero[1] = '\0';
 	if (ipx_neteqnn(ipx->ipx_sna.x_net, ipx_zeronet) && ifp != NULL) {
 		register struct ifaddr *ifa;
 
--- //depot/vendor/freebsd/src/sys/netipx/spx_usrreq.c	2005/02/21 22:00:52
+++ //depot/user/rwatson/netperf/sys/netipx/spx_usrreq.c	2005/02/27 16:23:38
@@ -692,6 +692,9 @@
 	return (0);
 }
 
+/*
+ * XXXRW: This is basically unimplemented -- should we GC?
+ */
 void
 spx_ctlinput(cmd, arg_as_sa, dummy)
 	int cmd;
@@ -1670,6 +1673,7 @@
 	error = spx_attach(so, proto, td);
 	if (error == 0) {
 		ipxp = sotoipxpcb(so);
+		/* XXXRW: For now, we accept a race here. */
 		((struct spxpcb *)ipxp->ipxp_pcb)->s_flags |=
 					(SF_HI | SF_HO | SF_PI);
 	}
--- //depot/vendor/freebsd/src/sys/netkey/keysock.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netkey/keysock.c	2005/02/27 16:23:38
@@ -214,6 +214,11 @@
 		pfkeystat.in_msgtype[msg->sadb_msg_type]++;
 	}
 
+	/*
+	 * XXXRW: This will almost certainly cause lock order problems;
+	 * we may need a netisr solution similar to that used in rtsock.
+	 */
+	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list) {
 		if (rp->rcb_proto.sp_family != PF_KEY)
 			continue;
@@ -261,6 +266,7 @@
 			continue;
 
 		if ((n = m_copy(m, 0, (int)M_COPYALL)) == NULL) {
+			mtx_unlock(&rawcb_mtx);
 			m_freem(m);
 			pfkeystat.in_nomem++;
 			return ENOBUFS;
@@ -275,6 +281,7 @@
 
 		n = NULL;
 	}
+	mtx_unlock(&rawcb_mtx);
 
 	if (so) {
 		error = key_sendup0(sotorawcb(so), m, 0);
--- //depot/vendor/freebsd/src/sys/netsmb/smb_trantcp.c	2005/01/07 01:52:23
+++ //depot/user/rwatson/netperf/sys/netsmb/smb_trantcp.c	2005/02/27 16:23:38
@@ -184,6 +184,9 @@
 	return 0;
 }
 
+/*
+ * XXXRW: nb_upcall() is called without Giant, which is probably safeish.
+ */
 static void
 nb_upcall(struct socket *so, void *arg, int waitflag)
 {
--- //depot/vendor/freebsd/src/sys/nfsclient/nfs_socket.c	2005/07/18 02:15:48
+++ //depot/user/rwatson/netperf/sys/nfsclient/nfs_socket.c	2005/07/19 11:47:08
@@ -1241,6 +1241,7 @@
 		 * Set r_rtt to -1 in case we fail to send it now.
 		 */
 		rep->r_rtt = -1;
+		/* XXXRW: Unlocked reads. */
 		if (sbspace(&so->so_snd) >= rep->r_mreq->m_pkthdr.len &&
 		   ((nmp->nm_flag & NFSMNT_DUMBTIMR) ||
 		    (rep->r_flags & R_SENT) ||
--- //depot/vendor/freebsd/src/sys/nfsserver/nfs_syscalls.c	2005/03/26 11:30:19
+++ //depot/user/rwatson/netperf/sys/nfsserver/nfs_syscalls.c	2005/06/01 10:10:04
@@ -608,6 +608,10 @@
 		NFSD_UNLOCK();
 		slp->ns_fp = NULL;
 		so = slp->ns_so;
+		/*
+		 * XXXRW: More general locking issues here relating to
+		 * upcalls.
+		 */
 		SOCKBUF_LOCK(&so->so_rcv);
 		so->so_rcv.sb_flags &= ~SB_UPCALL;
 		SOCKBUF_UNLOCK(&so->so_rcv);
--- //depot/vendor/freebsd/src/sys/pci/if_dc.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/pci/if_dc.c	2005/07/05 14:55:33
@@ -343,8 +343,6 @@
 #define SIO_SET(x)	DC_SETBIT(sc, DC_SIO, (x))
 #define SIO_CLR(x)	DC_CLRBIT(sc, DC_SIO, (x))
 
-#define IS_MPSAFE 	0
-
 static void
 dc_delay(struct dc_softc *sc)
 {
@@ -2190,8 +2188,6 @@
 	/* XXX: bleah, MTU gets overwritten in ether_ifattach() */
 	ifp->if_mtu = ETHERMTU;
 	ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX | IFF_MULTICAST;
-	if (!IS_MPSAFE)
-		ifp->if_flags |= IFF_NEEDSGIANT;
 	ifp->if_ioctl = dc_ioctl;
 	ifp->if_start = dc_start;
 	ifp->if_watchdog = dc_watchdog;
@@ -2272,7 +2268,7 @@
 #endif
 	ifp->if_capenable = ifp->if_capabilities;
 
-	callout_init(&sc->dc_stat_ch, IS_MPSAFE ? CALLOUT_MPSAFE : 0);
+	callout_init(&sc->dc_stat_ch, debug_mpsafenet ? CALLOUT_MPSAFE : 0);
 
 #ifdef SRM_MEDIA
 	sc->dc_srm_media = 0;
@@ -2306,8 +2302,7 @@
 	ether_ifattach(ifp, eaddr);
 
 	/* Hook interrupt last to avoid having to lock softc */
-	error = bus_setup_intr(dev, sc->dc_irq, INTR_TYPE_NET |
-	    (IS_MPSAFE ? INTR_MPSAFE : 0),
+	error = bus_setup_intr(dev, sc->dc_irq, INTR_TYPE_NET | INTR_MPSAFE,
 	    dc_intr, sc, &sc->dc_intrhand);
 
 	if (error) {
--- //depot/vendor/freebsd/src/sys/pci/if_pcn.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/pci/if_pcn.c	2005/07/05 14:55:33
@@ -631,7 +631,7 @@
 	ether_ifattach(ifp, (u_int8_t *) eaddr);
 
 	/* Hook interrupt last to avoid having to lock softc */
-	error = bus_setup_intr(dev, sc->pcn_irq, INTR_TYPE_NET,
+	error = bus_setup_intr(dev, sc->pcn_irq, INTR_TYPE_NET | INTR_MPSAFE,
 	    pcn_intr, sc, &sc->pcn_intrhand);
 
 	if (error) {
